package URLAnnotate;

use LWP::Simple qw($ua head get);
use base qw(Plugin);
use strict;
use vars qw($MAX_DOC_SIZE $URL_REGEX $TIMEOUT $ua);

$TIMEOUT = 4; #Wait for four seconds max.
$MAX_DOC_SIZE=200000; # Max documentsize to download

#Bad ass regex matching HTTP-URLs.
$URL_REGEX = '(?:(?:http)://(?:(?:(?:(?:(?:(?:[a-zA-Z0-9][-a-zA-Z0-9]*)?[a-zA-Z0-9])[.])*(?:[a-zA-Z][-a-zA-Z0-9]*[a-zA-Z0-9]|[a-zA-Z])[.]?)|(?:[0-9]+[.][0-9]+[.][0-9]+[.][0-9]+)))(?::(?:(?:[0-9]*)))?(?:/(?:(?:(?:(?:(?:(?:[a-zA-Z0-9\-_.!~*\'():@&=+$,]+|(?:%[a-fA-F0-9][a-fA-F0-9]))*)(?:;(?:(?:[a-zA-Z0-9\-_.!~*\'():@&=+$,]+|(?:%[a-fA-F0-9][a-fA-F0-9]))*))*)(?:/(?:(?:(?:[a-zA-Z0-9\-_.!~*\'():@&=+$,]+|(?:%[a-fA-F0-9][a-fA-F0-9]))*)(?:;(?:(?:[a-zA-Z0-9\-_.!~*\'():@&=+$,]+|(?:%[a-fA-F0-9][a-fA-F0-9]))*))*))*))(?:[?](?:(?:(?:[;/?:@&=+$,a-zA-Z0-9\-_.!~*\'()]+|(?:%[a-fA-F0-9][a-fA-F0-9]))*)))?))?)';

sub public
{
   my ($core, $who, $where, $msg) = @_;

   $who =~ /(.*)!/;

   return if($1 eq $core->mynick);

   my %config;
   $core->module_config(\%config, $where);

   return unless($config{enabled});
   
   my (@urls) = $msg =~ m/($URL_REGEX)/gi;

   $config{timeout} ||= $TIMEOUT;
   $config{max_doc_size} ||= $MAX_DOC_SIZE;

   $ua->timeout($config{timeout});

   foreach my $url (@urls) {
      my ($content_type,$content_length)=head($url);

      next unless ($content_type =~ m/^text\/html/ && $content_length < $config{max_doc_size});

      my $page = get($url);
      next unless $page;

      my ($title) = $page =~ m|<title>\s*(.*)\s*</title>|i;
      next unless $title;

      $title =~ s/[\n\r]//g;

      my $TU;
      if(length($url) > 70) {
	 $TU = get('http://tinyurl.com/api-create.php?url=' . $url);
	 if ($TU =~ m!(\Qhttp://tinyurl.com/\E\w+)!x) {
	    $TU = " $1";
	}
     }

      $core->msg($where, "[$title]$TU");
   }

   return;
}

sub first_run {}

__PACKAGE__->install({
        events => { public => 1 },
});
